// ******** Share Extension Web Page Processing ******** //
var MetaDataExtractionClass = function() {};

MetaDataExtractionClass.prototype = {
run: function(arguments) {
    arguments.completionFunction({
                                 "stringifiedJSON": extractMeta()
                                 });
}
};

// Must contain a global object named "ExtensionPreprocessingJS".
var ExtensionPreprocessingJS = new MetaDataExtractionClass;
// ******** Share Extension Web Page Processing ******** //


// ******** Used while evaluating webview javascript for metadata. (BrowserViewController) ******** //
(function() { return extractMeta();})();
// ******** Used while evaluating webview javascript for metadata. (BrowserViewController) ******** //


function extractMeta() {
    var attr = function(tag, attr) {
        var str = tag.getAttribute(attr);
        if (!str) {
            return undefined;
        }
        if (str.trim() === '') {
            return undefined;
        }
        return str;
    };
    
    var metaTags = !!document.querySelectorAll ? document.querySelectorAll('meta') : document.getElementsByTagName('meta');
    var meta = {};
    
    for (var i = 0; i < metaTags.length; ++i) {
        var tag = metaTags[i];
        meta[attr(tag, 'property') || attr(tag, 'name') || attr(tag, 'id')] = attr(tag, 'content') || attr(tag, 'value');
    }
    
    var linkTags = !!document.querySelectorAll ? document.querySelectorAll('link') : document.getElementsByTagName('link');
    var link = {};
    for (var i = 0; i < linkTags.length; ++i) {
        var tag = linkTags[i];
        link[attr(tag, 'rel')] = attr(tag, 'href');
    }
    
    var root = location.protocol + '//' + location.host;
    var description = meta['og:description'] || meta['twitter:description'] || meta['description'];
    var appName = meta['og:site_name'] || meta['application-name'] || meta['apple-mobile-web-app-title'];
    var title = meta['og:title'] || meta['twitter:title'] || (!!appName ? document.title : null);
    var titleToDisplay = (!title && description) ? description : title;
    var descriptionToDisplay = (!title && description) ? undefined : description;
    if (!titleToDisplay && !descriptionToDisplay) {
        titleToDisplay = document.title;
        descriptionToDisplay = location.href;
        if (!titleToDisplay) {
            titleToDisplay = descriptionToDisplay;descriptionToDisplay = undefined;
        }
    }
    
    try {
        return JSON.stringify({
                              'title': titleToDisplay || (descriptionToDisplay ? undefined : location.href),
                              'description': descriptionToDisplay,
                              'app-name': appName || document.title || location.hostname,
                              'app-icon': link['kik-icon'] || link['apple-touch-icon'] || link['apple-touch-icon-precomposed'] || link['shortcut icon'] || link['icon'] || root + '/apple-touch-icon.png',
                              'preview-image': meta['og:image'] || meta['og:image:src'] || meta['twitter:image'] || meta['twitter:image:src'] || link['img_src'],
                              'layout': (meta['twitter:card'] || '').trim().toLowerCase() === 'photo' ? 'photo' : 'article',
                              'url': link['canonical'] || location.href
                              });
    } catch (e) {
        return '{}';
    }
}